# Contributing to CESSDA Open Source Software

Thank you for considering contributing to CESSDA Open Source Software.

Please note that we welcome all forms of user feedback and are generally open to many forms of collaboration,
but please read this document carefully before proceeding.

## User feedback

### Reporting problems

We welcome all feedback you may have when using any of our tools and services.

If you encounter a problem, please use the "Report a problem" button you find at the lower right corner of the respective tool or service
and choose "Bug" as the value of the Components field.

### Suggesting Enhancements

To suggest new functionalities and possible future developments,
please use the "Report a problem" button you find at the lower right corner of the respective tool or service
and choose "New Feature" or "Improvement" as the value of the Components field.

## Contributing to the development

Development of all CESSDA tools and services is aligned with our roadmap and any functional requirements we have.

External contributions can be accepted, if they provide functionality CESSDA deems appropriate and are of acceptable quality.
Specific requirements and criteria may apply to specific tools.

If you want to contribute to CESSDA tools and services, please contact support@cessda.eu before proceeding.

### Practical matters

CESSDA ERIC reserves the right to accept or reject any contribution.

For CESSDA to consider your contribution, the following criteria must be met.

- You must sign the [CESSDA Contributor License Agreement](https://docs.google.com/forms/d/e/1FAIpQLSfS2sOjZ2Ax5nIhvONY5E1yVsDgMkNzl0yw2TbMTA-5MYdCXQ/viewform?usp=sf_link)
- You must adhere to [CESSDA's quality requirements](https://docs.tech.cessda.eu/software/requirements.html)
